# $Id: sqlrelay.spec,v 1.9 2003/07/03 11:09:42 dude Exp $

%define pythondir	%{_libdir}/python1.5
%define	phpextdir	%{_libdir}/php4
%define	zopedir		%{_libdir}/python/Products
%define	perl_sitelib	%(eval "`perl -V:sitelib`"; echo $sitelib)

Summary: Persistent database connection system.
Name: sqlrelay
Version: 0.33.1
Release: fr0.2
License: GPL/LGPL and Others
Group: System Environment/Daemons
Source0: http://prdownloads.sourceforge.net/sqlrelay/%{name}-%{version}.tar.gz
Source1: sqlrelay.init
Patch0: sqlrelay-0.33.1-pkgconfig.patch
URL: http://sqlrelay.sourceforge.net/
Buildroot: %{_tmppath}/%{name}-root
Requires: rudiments >= 0.25, libxml
BuildRequires: rudiments-devel >= 0.25.1, libxml-devel
%{?_with_gtk:BuildRequires: gtk+-devel}
%{?_with_mysql:BuildRequires: mysql-devel}
%{?_with_odbc:BuildRequires: unixODBC-devel}
%{?_with_postgresql:BuildRequires: postgresql-devel}
%{?_with_perl:BuildRequires: perl}
%{?_with_php:BuildRequires: php-devel}
%{?_with_python:BuildRequires: python-devel}
%{?_with_ruby:BuildRequires: ruby-devel}
%{?_with_zope:BuildRequires: python-devel}

%description
SQL Relay is a persistent database connection pooling, proxying and load 
balancing system for Unix and Linux supporting ODBC, Oracle, MySQL, mSQL, 
PostgreSQL, Sybase, MS SQL Server, IBM DB2, Interbase, Lago and SQLite with C, 
C++, Perl, Perl-DBD, Python, Python-DB, Zope, PHP, Ruby and Java APIs, command 
line clients, a GUI configuration tool and extensive documentation.  The APIs 
support advanced database operations such as bind variables, multi-row fetches,
client side result set caching and suspended transactions.  It is ideal for 
speeding up database-driven web-based applications, accessing databases from 
unsupported platforms, migrating between databases, distributing access to 
replicated databases and throttling database access.

Available rpmbuild rebuild options :
General :
--with gtk
Database :
--with mysql postgresql
--with db2 freetds interbase lago msql odbc oracle7 oracle8 sqlite sybase
Languages :
--with java perl php python ruby zope


%package devel
Summary: Development files for developing programs in C/C++ that use SQL Relay.
Group: Development/Libraries
Requires: %{name} = %{version}, pkgconfig

%description devel
Header files and static libraries to use for developing programs in C or C++
that use SQL Relay.


%package config-gtk
Summary: SQL Relay GUI configuration tool.
Group: Applications/Databases
Requires: %{name} = %{version}, gtk+

%description config-gtk
GTK-based configuration tool for SQL Relay.


%package db2
Summary: SQL Relay connection daemon for IBM DB2.
Group: Applications/Databases
Requires: %{name} = %{version}

%description db2
SQL Relay connection daemon for IBM DB2.


%package freetds
Summary: SQL Relay connection daemon for FreeTDS (Sybase and MS SQL Server).
Group: Applications/Databases
Requires: %{name} = %{version}

%description freetds
SQL Relay connection daemon for FreeTDS (Sybase and MS SQL Server).


%package interbase
Summary: SQL Relay connection daemon for Interbase.
Group: Applications/Databases
Requires: %{name} = %{version}

%description interbase
SQL Relay connection daemon for Interbase.


%package lago
Summary: SQL Relay connection daemon for Lago.
Group: Applications/Databases
Requires: %{name} = %{version}

%description lago
SQL Relay connection daemon for Lago.


%package msql
Summary: SQL Relay connection daemon for mSQL.
Group: Applications/Databases
Requires: %{name} = %{version}

%description msql
SQL Relay connection daemon for mSQL.


%package mysql
Summary: SQL Relay connection daemon for MySQL.
Group: Applications/Databases
Requires: %{name} = %{version}, mysql

%description mysql
SQL Relay connection daemon for MySQL.


%package odbc
Summary: SQL Relay connection daemon for ODBC.
Group: Applications/Databases
Requires: %{name} = %{version}

%description odbc
SQL Relay connection daemon for ODBC.


%package oracle7
Summary: SQL Relay connection daemon for Oracle 7.
Group: Applications/Databases
Requires: %{name} = %{version}

%description oracle7
SQL Relay connection daemon for Oracle 7.


%package oracle8
Summary: SQL Relay connection daemon for Oracle 8.
Group: Applications/Databases
Requires: %{name} = %{version}

%description oracle8
SQL Relay connection daemon for Oracle 8.


%package postgresql
Summary: SQL Relay connection daemon for PostgreSQL.
Group: Applications/Databases
Requires: %{name} = %{version}, postgresql

%description postgresql
SQL Relay connection daemon for PostgreSQL.


%package sqlite
Summary: SQL Relay connection daemon for SQLite.
Group: Applications/Databases
Requires: %{name} = %{version}

%description sqlite
SQL Relay connection daemon for SQLite.


%package sybase
Summary: SQL Relay connection daemon for Sybase.
Group: Applications/Databases
Requires: %{name} = %{version}

%description sybase
SQL Relay connection daemon for Sybase.


%package java
Summary: SQL Relay modules for Java.
Group: Development/Languages
Requires: %{name} = %{version}

%description java
SQL Relay modules for Java.


%package perl
Summary: SQL Relay modules for Perl.
Group: Development/Languages
Requires: %{name} = %{version}, perl

%description perl
SQL Relay modules for Perl.


%package php
Summary: SQL Relay modules for PHP.
Group: Development/Languages
Requires: %{name} = %{version}, php

%description php
SQL Relay modules for PHP.


%package python
Summary: SQL Relay modules for Python.
Group: Development/Languages
Requires: %{name} = %{version}, python

%description python
SQL Relay modules for Python.


%package ruby
Summary: SQL Relay modules for Ruby.
Group: Development/Languages
Requires: %{name} = %{version}, ruby

%description ruby
SQL Relay modules for Ruby.


%package zope
Summary: SQL Relay modules for Zope.
Group: Development/Languages
Requires: %{name} = %{version}, Zope

%description zope
SQL Relay modules for Zope.


%prep
%setup -q
%patch -p1 -b .pkgconfig

%build
%configure \
	%{?_with_gtk} \
	%{?_with_db2} \
	%{?_with_freetds} \
	%{?_with_interbase} \
	%{?_with_lago} \
	%{?_with_msql} \
	%{?_with_mysql} \
	%{?_with_odbc} \
	%{?_with_oracle7} \
	%{?_with_oracle8} \
	%{?_with_postgresql} \
	%{?_with_sqlite} \
	%{?_with_sybase} \
	%{?_with_java} \
	%{?_with_perl} \
	%{?_with_php} \
	%{?_with_python} \
	%{?_with_ruby} \
	%{?_with_zope}
make

%install
rm -rf %{buildroot}
# No, we don't want all the hardcoded init stuff to happen...
perl -pi -e 's/Linux|chkconfig/Foo/g' init/Makefile
%makeinstall \
	incdir=%{buildroot}%{_includedir} \
	PYTHONDIR=%{buildroot}%{pythondir} \
	PHPEXTDIR=%{buildroot}%{phpextdir} \
	TCLLIBSPATH=%{buildroot}%{_libdir} \
	PREFIX=%{buildroot}%{_prefix}

mv -f	%{buildroot}%{_sysconfdir}/sqlrelay.conf.example \
	%{buildroot}%{_sysconfdir}/sqlrelay.conf

install -D -m 755 %{SOURCE1} %{buildroot}/etc/init.d/sqlrelay
mkdir -p %{buildroot}/etc/sysconfig
cat > %{buildroot}/etc/sysconfig/sqlrelay << EOF
# Enter here all SQL Relay connections to start automatically with the
# service command. (one per line)

defaultid

EOF

rm -f doc/Makefile


%pre
# Add the "sqlrelay" user
/usr/sbin/useradd -c "SQL Relay" -u 50 -s "" \
	-r -d %{_localstatedir}/sqlrelay sqlrelay 2> /dev/null || :

%post
/sbin/ldconfig
if [ $1 = 1 ]; then
	/sbin/chkconfig --add sqlrelay
fi

%preun
if [ $1 = 0 ]; then
	/sbin/service sqlrelay stop> /dev/null 2>&1 || :
	/sbin/chkconfig --del sqlrelay
fi

%postun
/sbin/ldconfig
if [ "$1" -ge "1" ]; then
	/sbin/service sqlrelay condrestart >/dev/null 2>&1 || :
fi


%clean
#rm -rf %{buildroot}


%files
%defattr(-, root, root)
%doc AUTHORS COPYING ChangeLog NEWS TODO etc/sqlrelay.conf.example doc
%config(noreplace) %attr(600, sqlrelay, sqlrelay) %{_sysconfdir}/sqlrelay.conf
%config %attr(600, root, root) %{_sysconfdir}/sqlrelay.dtd
%config(noreplace) %attr(600, root, root) /etc/sysconfig/sqlrelay
/etc/init.d/sqlrelay
%{_bindir}/backupschema
%{_bindir}/fields
%{_bindir}/query
%{_bindir}/sqlr-cachemanager
%{_bindir}/sqlr-listener
%{_bindir}/sqlr-listener-debug
%{_bindir}/sqlr-scaler
%{_bindir}/sqlrsh
%{_bindir}/sqlr-start
%{_bindir}/sqlr-stop
%{_libdir}/*.so*
%{_localstatedir}/sqlrelay/tmp
%{_localstatedir}/sqlrelay/cache
%{_localstatedir}/sqlrelay/debug

%files devel
%defattr(-, root, root)
%{_includedir}/sqlrelay
%{_libdir}/*.a
%{_libdir}/pkgconfig/sqlrclientwrapper.pc

%{?_with_gtk:%files config-gtk}
%{?_with_gtk:%defattr(-, root, root)}
%{?_with_gtk:%{_bindir}/sqlr-config-gtk}

%{?_with_db2:%files db2}
%{?_with_db2:%defattr(-, root, root)}
%{?_with_db2:%{_bindir}/sqlr-connection-db2*}

%{?_with_freetds:%files freetds}
%{?_with_freetds:%defattr(-, root, root)}
%{?_with_freetds:%{_bindir}/sqlr-connection-freetds*}

%{?_with_interbase:%files interbase}
%{?_with_interbase:%defattr(-, root, root)}
%{?_with_interbase:%{_bindir}/sqlr-connection-interbase*}

%{?_with_lago:%files lago}
%{?_with_lago:%defattr(-, root, root)}
%{?_with_lago:%{_bindir}/sqlr-connection-lago*}

%{?_with_msql:%files msql}
%{?_with_msql:%defattr(-, root, root)}
%{?_with_msql:%{_bindir}/sqlr-connection-msql*}

%{?_with_mysql:%files mysql}
%{?_with_mysql:%defattr(-, root, root)}
%{?_with_mysql:%{_bindir}/sqlr-connection-mysql*}

%{?_with_odbc:%files odbc}
%{?_with_odbc:%defattr(-, root, root)}
%{?_with_odbc:%{_bindir}/sqlr-connection-odbc*}

%{?_with_oracle7:%files oracle7}
%{?_with_oracle7:%defattr(-, root, root)}
%{?_with_oracle7:%{_bindir}/sqlr-connection-oracle7*}

%{?_with_oracle8:%files oracle8}
%{?_with_oracle8:%defattr(-, root, root)}
%{?_with_oracle8:%{_bindir}/sqlr-connection-oracle8*}

%{?_with_postgresql:%files postgresql}
%{?_with_postgresql:%defattr(-, root, root)}
%{?_with_postgresql:%{_bindir}/sqlr-connection-postgresql*}

%{?_with_sqlite:%files sqlite}
%{?_with_sqlite:%defattr(-, root, root)}
%{?_with_sqlite:%{_bindir}/sqlr-connection-sqlite*}

%{?_with_sybase:%files sybase}
%{?_with_sybase:%defattr(-, root, root)}
%{?_with_sybase:%{_bindir}/sqlr-connection-sybase*}

%{?_with_java:%files }
%{?_with_java:%defattr(-, root, root)}
%{?_with_java:%{_prefix}/java/*}

%{?_with_perl:%files perl}
%{?_with_perl:%defattr(-, root, root)}
%{?_with_perl:%{perl_sitelib}/DBD/SQLRelay.pm}
%{?_with_perl:%{perl_sitearch}/Firstworks}
%{?_with_perl:%{perl_sitearch}/auto/Firstworks}
%{?_with_perl:%{_mandir}/man3/*.3pm*}

%{?_with_php:%files php}
%{?_with_php:%defattr(-, root, root)}
%{?_with_php:%{phpextdir}/sql_relay.so}

%{?_with_python:%files python}
%{?_with_python:%defattr(-, root, root)}
%{?_with_python:%{_bindir}/query.py}
%{?_with_python:%{pythondir}/site-packages/SQLRelay}

%{?_with_ruby:%files ruby}
%{?_with_ruby:%defattr(-, root, root)}
%{?_with_ruby:%{_prefix}/lib/ruby/site_ruby/*/*/*.so}
%{?_with_ruby:%{_prefix}/lib/ruby/site_ruby/*/DBD/SQLRelay}

%{?_with_zope:%files zope}
%{?_with_zope:%defattr(-, root, root)}
%{?_with_zope:%{zopedir}/ZSQLRelayDA}


%changelog
* Mon Mar 10 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 0.33 pre-release.
- New pkgconfig patch.

* Thu Oct 10 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Change sqlrelay uid from 48 to 50 (48 is apache!).

* Wed Oct  2 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Cleanup the --with options and list them in the %%description.

* Thu Jul  4 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Source oracle.sh in the init script for Red Hat 7.3.

* Wed May 15 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Added Julien's pkgconfig patch.

* Fri Apr 26 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Polished the init script, too bad sqlr-start and sqlr-stop don't seem
  to have exit values different than 0 :-( It's "OK" whatever happens.

* Thu Apr 25 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Added the sysconfig entry to start connections automatically.
- Big updates to the init script.

* Fri Apr 19 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Finished the perl package rewrite.
- Added an init script.

* Mon Apr 15 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Spec file rewrite start.

